WhatsApp Template Management API

The Messages API now offers the WhatsApp Template Management API that allow you to manage templates for your WABAs and cut out the manual step of submitting and checking templates manually. You can manage your templates using the Template Management API, including adding new templates, retrieving their statuses, and deleting any that are already in use. Different sorts of media can be sent with each WhatsApp message template. You can manage your media files via the API and set up extra features to improve their functionality.

Télécharger la spécification OpenAPI

List Templates

Get a list of templates,and their associated metadata, for the specified WABA ID. If multiple language variants exist for a template, each variant will be returned as a separate template object.

gethttps://api.nexmo.com/v2/whatsapp-manager/wabas/:id/templates

Authentification

CléDescriptionExemple
Authorization

Votre jeton web JSON.
En savoir plus sur les JWT

Headers

Bearer <JWT>

Trajectoire Paramètres

id
string
Exigée

The id of the WABA

Demande de renseignements Paramètres

limit
number
Min1
Max500
Défaut25
exemple10

The number of templates to return in the list. Although the max size is 500, for large datasets it is recommended to use a lower limit and instead use pagination to avoid potential timeouts.

before
string
exempleMAZDZD

A cursor point used for a paginated request to indicate the template to paginate backwards from.

after
string
exempleMjQZD

A cursor point used for a paginated request to indicate the template to paginate forwards from.

category
string
exempleUTILITY

A filter for returning only templates matching a specific category.

Il doit s'agir de l'un d'entre eux :UTILITYAUTHENTICATIONMARKETING
content
string
exemplespecial offer

A search filter representing the content of a template. Only matching templates will be returned in the list.

language
string
exempleen

A filter for returning only templates matching a specific language code. A list of supported languages is available in the WhatsApp documentation

name
string
exempleMy Template

A search filter representing the name, either full or partial, of a template. Only matching templates will be returned in the list.

name_or_content
string
exemplespecial offer

A search filter representing the name, either full or partial, or content of a template. Only matching templates will be returned in the list.

quality_score
string
exempleRED

A search filter representing the quality score of a template. Only matching templates will be returned in the list.

Il doit s'agir de l'un d'entre eux :GREENYELLOWREDUNKNOWN
status
string
exempleAPPROVED

A filter for returning only templates matching a specific status.

Il doit s'agir de l'un d'entre eux :APPROVEDIN_APPEALPENDINGREJECTEDDISABLEDPAUSEDLIMIT_EXCEEDED

Réponses
Type de contenu
application/json

OK

paging
object
cursors
object
before
string
exempleMAZDZD

The template before the first template in the current list

after
string
exempleMjQZD

The template after the last template in the current list

next
string(uri)
exemplehttps://api.nexmo.com/v2/whatsapp-manager/wabas/106499765517625/templates?after=MwZDZD

A URI to ge the next paginated page.

previous
string(uri)
exemplehttps://api.nexmo.com/v2/whatsapp-manager/wabas/106499765517625/templates?before=MgZDZD

A URI to ge the previous paginated page.

templates
array

An array of templates in the current list

id
string
exemple1045638762820500

The unique identifier for this template.

name
string
exemplesample_issue_resolution

The name of the template

language
string
exempleen

The language of the template. The same template name can be used for multiple language versions. A list of supported languages is available in the WhatsApp documentation

status
string
exempleAPPROVED

The status of the template. Templates with a status of APPROVED can be used in WhatsApp template messages.

Il doit s'agir de l'un d'entre eux :APPROVEDREJECTEDIN_APPEALPENDINGPENDING_DELETIONDELETEDDISABLEDLOCKED
category
string
exempleUTILITY

The category of the template. This determines the purpose of the template. Note: until June 1st 2023 some older template categories may be listed. These should be updated to one the valid categories or they will be automatically migrated.

Il doit s'agir de l'un d'entre eux :UTILITYAUTHENTICATIONMARKETING
previous_category
string
exempleMARKETING

If the template has been updated to a different category, shows the previous category of the template.

components
array

An array of objects representing the parts of the template itself.

N'importe lequel
type
string
exempleBODY

The type of template component.

Il doit s'agir de l'un d'entre eux :HEADERBODYFOOTER
format
string
exempleTEXT

The format of the template component. Where type is HEADER can be TEXT, IMAGE, DOCUMENT, or VIDEO. Where type is BODY or FOOTER, must be TEXT.

text
string
exempleYour parcel from {{1}} is due to arrive on {{2}} between {{3}} and {{4}}.

The text to be displayed in this template component. EIther plain text or text with placeholders 1.

Exemple Réponse

{
   "paging": {
      "cursors": {
         "before": "MAZDZD",
         "after": "MjQZD"
      },
      "next": "https://api.nexmo.com/v2/whatsapp-manager/wabas/106499765517625/templates?after=MwZDZD",
      "previous": "https://api.nexmo.com/v2/whatsapp-manager/wabas/106499765517625/templates?before=MgZDZD"
   },
   "templates": [
      {
         "id": "1045638762820500",
         "name": "sample_issue_resolution",
         "language": "en",
         "status": "APPROVED",
         "category": "UTILITY",
         "previous_category": "MARKETING",
         "components": [
            {
               "type": "BODY",
               "format": "TEXT",
               "text": "Your parcel from {{1}} is due to arrive on {{2}} between {{3}} and {{4}}."
            }
         ]
      }
   ]
}

Create Template

Submit a new template to be associated with this WABA

posthttps://api.nexmo.com/v2/whatsapp-manager/wabas/:id/templates

Authentification

CléDescriptionExemple
Authorization

Votre jeton web JSON.
En savoir plus sur les JWT

Headers

Bearer <JWT>

Trajectoire Paramètres

id
string
Exigée

The id of the WABA

En-tête Paramètres

Content-Type
string

application/json

Corps de la demande
Type de contenu
application/json

L'un des
name
string
Exigée
exemplesample_issue_resolution

The name of the template

language
string
Exigée
exempleen

The language of the template. The same template name can be used for multiple language versions. A list of supported languages is available in the WhatsApp documentation. Note: Adding new languages on legacy template categories has been disabled by Meta, see the documentation for Language Variants and Categories

category
string
Exigée
exempleUTILITY

The required category of the template. The category determines what the template will be used for. Note: Adding new languages on legacy template categories has been disabled by Meta, see the documentation for Language Variants and Categories

Il doit s'agir de l'un d'entre eux :UTILITYAUTHENTICATIONMARKETING
allow_category_change
boolean
exempletrue

This field is now deprecated. This functionality is now enabled by default by Meta and cannot be disabled. See the Meta documentation for more infomration.

An optional parameter which, when set to true, can avoid template rejection due to mis-categorization. Including this parameter, with a value of true, will allow Meta to re-assign the template to a different category as appropriate.

Il doit s'agir de l'un d'entre eux :truefalse
components
array
Exigée

An array of objects representing the parts of the template itself.

type
string
exempleBODY

The type of template component. HEADER, FOOTER, and BUTTONS are optional, a BODY is always a required component of a template.

Il doit s'agir de l'un d'entre eux :HEADERBODYFOOTERBUTTONS
format
string
exempleTEXT

The format of the template component. For a Text Template, format is always TEXT for HEADER, BODY or FOOTER components.

Il doit s'agir de l'un d'entre eux :TEXT
text
string
exempleYour parcel from {{1}} is due to arrive on {{2}} between {{3}} and {{4}}.

The text to be displayed in this template component. EIther plain text or text with placeholders 1.

example
object

Must be included when placeholders are used in the text.

body_text
array

An array containing one array. The inner array contains strings, with one item for each placeholder used in the text. Must be included when format is text and placeholders are included in the text.

buttons
array

Where type is set to BUTTONS, an array of button objects representing the properties of each button.

type
string
exempleQUICK_REPLY

The type of button.

Il doit s'agir de l'un d'entre eux :QUICK_REPLYURLPHONE_NUMBER
text
string
exempleYes

The text to appear on the button.

url
string(uri)
exemplehttps://example.com/special-offer-opt-in

A URL to which the end-user will be directed when hitting the button. Must be set when type is URL.

phone_number
string
exemple8001111111

Phone number to which a phone call would be placed by the end-user when hitting the button. Must be set when type is PHONE_NUMBER.

Exemple Demande

{
   "name": "sample_issue_resolution",
   "language": "en",
   "category": "UTILITY",
   "allow_category_change": true,
   "components": [
      {
         "type": "BODY",
         "format": "TEXT",
         "text": "Your parcel from {{1}} is due to arrive on {{2}} between {{3}} and {{4}}.",
         "example": {
            "body_text": "[['Courier','May 1st', '3:00PM', '4:00PM']]"
         },
         "buttons": [
            {
               "type": "QUICK_REPLY",
               "text": "Yes",
               "url": "https://example.com/special-offer-opt-in",
               "phone_number": "8001111111"
            }
         ]
      }
   ]
}

Réponses
Type de contenu
application/json

OK

id
string
Exigée
exemple408766354711449

The unique ID of the created template.

Exemple Réponse

{
   "id": "408766354711449"
}

Delete Template

Delete a template of the specified name associated with the WABA ID

deletehttps://api.nexmo.com/v2/whatsapp-manager/wabas/:id/templates

Authentification

CléDescriptionExemple
Authorization

Votre jeton web JSON.
En savoir plus sur les JWT

Headers

Bearer <JWT>

Trajectoire Paramètres

id
string
Exigée

The id of the WABA

Demande de renseignements Paramètres

name
string

The name of the template to be deleted. The name is required, but if specified without hsm_id being specified then all templates matching that name will be deleted.

hsm_id
string

The ID of the specific template to be deleted. Only the template matching both the specified name and hsm_id will be deleted.

Réponses

No Content

Get Template

Get details of an existing template identified by the WABA and Template ID

gethttps://api.nexmo.com/v2/whatsapp-manager/wabas/:id/templates/:template_id

Authentification

CléDescriptionExemple
Authorization

Votre jeton web JSON.
En savoir plus sur les JWT

Headers

Bearer <JWT>

Trajectoire Paramètres

id
string
Exigée

The id of the WABA

template_id
string
Exigée

The id of the template

Réponses
Type de contenu
application/json

OK

id
string
exemple1045638762820500

The unique identifier for this template.

name
string
exemplesample_issue_resolution

The name of the template

language
string
exempleen

The language of the template. The same template name can be used for multiple language versions. A list of supported languages is available in the WhatsApp documentation

status
string
exempleAPPROVED

The status of the template. Templates with a status of APPROVED can be used in WhatsApp template messages.

Il doit s'agir de l'un d'entre eux :APPROVEDREJECTEDIN_APPEALPENDINGPENDING_DELETIONDELETEDDISABLEDLOCKED
category
string
exempleUTILITY

The category of the template. This determines the purpose of the template. Note: until June 1st 2023 some older template categories may be listed. These should be updated to one the valid categories or they will be automatically migrated.

Il doit s'agir de l'un d'entre eux :UTILITYAUTHENTICATIONMARKETING
previous_category
string
exempleMARKETING

If the template has been updated to a different category, shows the previous category of the template.

components
array

An array of objects representing the parts of the template itself.

N'importe lequel
type
string
exempleBODY

The type of template component.

Il doit s'agir de l'un d'entre eux :HEADERBODYFOOTER
format
string
exempleTEXT

The format of the template component. Where type is HEADER can be TEXT, IMAGE, DOCUMENT, or VIDEO. Where type is BODY or FOOTER, must be TEXT.

text
string
exempleYour parcel from {{1}} is due to arrive on {{2}} between {{3}} and {{4}}.

The text to be displayed in this template component. EIther plain text or text with placeholders 1.

Exemple Réponse

{
   "id": "1045638762820500",
   "name": "sample_issue_resolution",
   "language": "en",
   "status": "APPROVED",
   "category": "UTILITY",
   "previous_category": "MARKETING",
   "components": [
      {
         "type": "BODY",
         "format": "TEXT",
         "text": "Your parcel from {{1}} is due to arrive on {{2}} between {{3}} and {{4}}."
      }
   ]
}

Update Template

Update an existing template identified by the WABA and Template ID

puthttps://api.nexmo.com/v2/whatsapp-manager/wabas/:id/templates/:template_id

Authentification

CléDescriptionExemple
Authorization

Votre jeton web JSON.
En savoir plus sur les JWT

Headers

Bearer <JWT>

En-tête Paramètres

Content-Type
string

application/json

Trajectoire Paramètres

id
string
Exigée

The id of the WABA

template_id
string
Exigée

The id of the template to be updated

Corps de la demande
Type de contenu
application/json

L'un des
name
string
Exigée
exemplesample_issue_resolution

The name of the template

language
string
Exigée
exempleen

The language of the template. The same template name can be used for multiple language versions. A list of supported languages is available in the WhatsApp documentation. Note: Adding new languages on legacy template categories has been disabled by Meta, see the documentation for Language Variants and Categories

category
string
Exigée
exempleUTILITY

The required category of the template. The category determines what the template will be used for. Note: Adding new languages on legacy template categories has been disabled by Meta, see the documentation for Language Variants and Categories

Il doit s'agir de l'un d'entre eux :UTILITYAUTHENTICATIONMARKETING
allow_category_change
boolean
exempletrue

This field is now deprecated. This functionality is now enabled by default by Meta and cannot be disabled. See the Meta documentation for more infomration.

An optional parameter which, when set to true, can avoid template rejection due to mis-categorization. Including this parameter, with a value of true, will allow Meta to re-assign the template to a different category as appropriate.

Il doit s'agir de l'un d'entre eux :truefalse
components
array
Exigée

An array of objects representing the parts of the template itself.

type
string
exempleBODY

The type of template component. HEADER, FOOTER, and BUTTONS are optional, a BODY is always a required component of a template.

Il doit s'agir de l'un d'entre eux :HEADERBODYFOOTERBUTTONS
format
string
exempleTEXT

The format of the template component. For a Text Template, format is always TEXT for HEADER, BODY or FOOTER components.

Il doit s'agir de l'un d'entre eux :TEXT
text
string
exempleYour parcel from {{1}} is due to arrive on {{2}} between {{3}} and {{4}}.

The text to be displayed in this template component. EIther plain text or text with placeholders 1.

example
object

Must be included when placeholders are used in the text.

body_text
array

An array containing one array. The inner array contains strings, with one item for each placeholder used in the text. Must be included when format is text and placeholders are included in the text.

buttons
array

Where type is set to BUTTONS, an array of button objects representing the properties of each button.

type
string
exempleQUICK_REPLY

The type of button.

Il doit s'agir de l'un d'entre eux :QUICK_REPLYURLPHONE_NUMBER
text
string
exempleYes

The text to appear on the button.

url
string(uri)
exemplehttps://example.com/special-offer-opt-in

A URL to which the end-user will be directed when hitting the button. Must be set when type is URL.

phone_number
string
exemple8001111111

Phone number to which a phone call would be placed by the end-user when hitting the button. Must be set when type is PHONE_NUMBER.

Exemple Demande

{
   "name": "sample_issue_resolution",
   "language": "en",
   "category": "UTILITY",
   "allow_category_change": true,
   "components": [
      {
         "type": "BODY",
         "format": "TEXT",
         "text": "Your parcel from {{1}} is due to arrive on {{2}} between {{3}} and {{4}}.",
         "example": {
            "body_text": "[['Courier','May 1st', '3:00PM', '4:00PM']]"
         },
         "buttons": [
            {
               "type": "QUICK_REPLY",
               "text": "Yes",
               "url": "https://example.com/special-offer-opt-in",
               "phone_number": "8001111111"
            }
         ]
      }
   ]
}

Réponses

No Content

Media Upload

Upload media files to the WhatsApp platform. Once uploaded, you can use an uploaded file's handle to create a media template.

posthttps://api.nexmo.com/v2/whatsapp-manager/media/uploads

Authentification

CléDescriptionExemple
Authorization

Votre jeton web JSON.
En savoir plus sur les JWT

Headers

Bearer <JWT>

Demande de renseignements Paramètres

file_type
string

The file's MIME type. Valid values are: image/jpeg, image/jpg, image/png, and video/mp4.

En-tête Paramètres

Content-Type
string

multipart/form-data

Corps de la demande
Type de contenu
multipart/form-data

mediafile
string(binary)

The file to be uploaded. See an example cURL request

Exemple Demande

POST /v2/whatsapp-manager/media/uploads HTTP/1.1
Host: api.nexmo.com
Content-Type: application/x-www-form-urlencoded
Content-Length: 16

mediafile=string

Réponses
Type de contenu
application/json

OK

h
string
exemple:c2FtcGxlLm1wNA==:image/jpeg:GKAj0gAUCZmJ1voFADip2iIAAAAAbugbAAAA:e:1472075513:ARZ_3ybzrQqEaluMUdI

The uploaded file's file handle

Exemple Réponse

{
   "h": ":c2FtcGxlLm1wNA==:image/jpeg:GKAj0gAUCZmJ1voFADip2iIAAAAAbugbAAAA:e:1472075513:ARZ_3ybzrQqEaluMUdI"
}

Erreurs

Voici une liste non exhaustive des codes d'erreur susceptibles de se produire lors de l'utilisation de cette API.

Ces codes s'ajoutent à ceux de notre site codes d'erreur génériques.

CodeInformations
1000

Throttled - You have exceeded the submission capacity allowed on this account. Please wait and retry

1030

Internal error - There was an error processing your request in the Platform.